
int midi_get_timidity_client_id();
void midi_main_loop(void *ptr);
void midi_key_input(int *ch, int *note, int *vel);
void midi_init();
int midi_open_input();
int midi_open_output_client();
void midi_set_preset();
int midi_launch_timidity_and_connect(char *sffile_name);
int midi_get_chorus_level();
void midi_set_chorus_level(int level);
void midi_set_all_voice_sts();
void midi_set_stop_volume();
void midi_enable_chorus(int flg);
void midi_enable_tremulant(int div, int flg);
void midi_set_pitch_level(double);
double midi_get_pitch_level();


#ifdef _WINDOWS_H
void CALLBACK midi_in_proc(HMIDIIN hMidiIn, UINT wMsg,DWORD dwInstance,DWORD dwParam1,DWORD dwParam2);
#endif

enum {
  ACT_CALLREG=0,
  ACT_VOLUME
};


typedef struct {
  int action;
  int action_div;
  int input_ch;
  int event_type;
  int event_param;
  int range_low;
  int range_high;
} ACT_EVENT;
