

#include <gtk/gtk.h>
#include <string.h>
#include <malloc.h>
#include <unistd.h>

#include "common.h"
#include "midi.h"


static GtkWidget *dlg_chg_chorus;
static GtkWidget *scale_chorus;
static GtkObject *adj_chorus;





// 饹٥ ѹ OK
gint chg_chorus_level_dialog_ok(GtkWidget *widget, gpointer data)
{
  int chorus;
  chorus = (int)GTK_ADJUSTMENT(adj_chorus)->value;
  midi_set_chorus_level(chorus);
  gtk_widget_destroy(dlg_chg_chorus);
  return 0;
}

// chorusѹ 󥻥
gint chg_chorus_level_dialog_cancel(GtkWidget *widget, gpointer data)
{
  gtk_widget_destroy(dlg_chg_chorus);
  return 0;
}


/*
  ȥåñ̤Υƥ
*/
gint chg_chorus_level_dialog(GtkWidget *widget, gpointer data)
{
  GtkWidget *button;

  dlg_chg_chorus = gtk_dialog_new();
  gtk_window_set_title(GTK_WINDOW(dlg_chg_chorus), "Chorus Level");
 
  gtk_widget_show(dlg_chg_chorus);

  adj_chorus = gtk_adjustment_new (midi_get_chorus_level(),
				     1.0, 8000.0, 1.0, 1.0, 1.0);
  scale_chorus = gtk_hscale_new (GTK_ADJUSTMENT (adj_chorus));
  gtk_widget_set_usize (GTK_WIDGET (scale_chorus), 150, 30);
  gtk_range_set_update_policy (GTK_RANGE (scale_chorus), 
			       GTK_UPDATE_DELAYED);
  gtk_scale_set_digits (GTK_SCALE (scale_chorus), 0); //ʲ
  gtk_scale_set_draw_value (GTK_SCALE (scale_chorus), TRUE); //ɽ
  gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dlg_chg_chorus)->vbox), 
		     scale_chorus, TRUE,TRUE,0);
  gtk_widget_show(scale_chorus);


  button = gtk_button_new_with_label("OK");
  gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dlg_chg_chorus)->action_area), 
		     button, TRUE,FALSE,3);
  gtk_signal_connect(GTK_OBJECT(button), "clicked",
		     GTK_SIGNAL_FUNC(chg_chorus_level_dialog_ok), (gpointer)0);
  gtk_widget_show(button);

  button = gtk_button_new_with_label("CANCEL");
  gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dlg_chg_chorus)->action_area), 
		     button, TRUE,FALSE,3);
  gtk_signal_connect(GTK_OBJECT(button), "clicked", 
		     GTK_SIGNAL_FUNC(chg_chorus_level_dialog_cancel), 
		     (gpointer)0);
  gtk_widget_show(button);
 
  gtk_window_set_default_size     (GTK_WINDOW(dlg_chg_chorus), 400,100);
  gtk_grab_add(GTK_WIDGET(dlg_chg_chorus));
  return 0;
}

